

package hu.bme.mit.cps.k8slab.solarperformanceforecast;

/* SolarPerformancePublisher.java

A publication of data of type SolarPerformance

This file is derived from code automatically generated by the rtiddsgen 
command:

rtiddsgen -language java -example <arch> .idl

Example publication of type SolarPerformance automatically generated by 
'rtiddsgen' To test them follow these steps:

(1) Compile this file and the example subscription.

(2) Start the subscription on the same domain used for RTI Data Distribution
Service with the command
java SolarPerformanceSubscriber <domain_id> <sample_count>

(3) Start the publication on the same domain used for RTI Data Distribution
Service with the command
java SolarPerformancePublisher <domain_id> <sample_count>

(4) [Optional] Specify the list of discovery initial peers and 
multicast receive addresses via an environment variable or a file 
(in the current working directory) called NDDS_DISCOVERY_PEERS.  

You can run any number of publishers and subscribers programs, and can 
add and remove them dynamically from the domain.

Example:

To run the example application on domain <domain_id>:

Ensure that $(NDDSHOME)/lib/<arch> is on the dynamic library path for
Java.                       

On Unix: 
add $(NDDSHOME)/lib/<arch> to the 'LD_LIBRARY_PATH' environment
variable

On Windows:
add %NDDSHOME%\lib\<arch> to the 'Path' environment variable

Run the Java applications:

java -Djava.ext.dirs=$NDDSHOME/lib/java SolarPerformancePublisher <domain_id>

java -Djava.ext.dirs=$NDDSHOME/lib/java SolarPerformanceSubscriber <domain_id>        
*/

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.rti.dds.domain.*;
import com.rti.dds.infrastructure.*;
import com.rti.dds.publication.*;
import com.rti.dds.subscription.DataReader;
import com.rti.dds.subscription.DataReaderAdapter;
import com.rti.dds.subscription.DataReaderListener;
import com.rti.dds.subscription.InstanceStateKind;
import com.rti.dds.subscription.SampleInfo;
import com.rti.dds.subscription.SampleInfoSeq;
import com.rti.dds.subscription.SampleStateKind;
import com.rti.dds.subscription.Subscriber;
import com.rti.dds.subscription.ViewStateKind;
import com.rti.dds.topic.*;
import com.rti.ndds.config.*;

import hu.bme.mit.cps.k8slab.Brightness;
import hu.bme.mit.cps.k8slab.BrightnessDataReader;
import hu.bme.mit.cps.k8slab.BrightnessSeq;
import hu.bme.mit.cps.k8slab.BrightnessTypeSupport;
import hu.bme.mit.cps.k8slab.SolarPerformance;
import hu.bme.mit.cps.k8slab.SolarPerformanceDataWriter;
import hu.bme.mit.cps.k8slab.SolarPerformanceTypeSupport;

// ===========================================================================

public class SolarPerformancePublisher {
    // -----------------------------------------------------------------------
    // Public Methods
    // -----------------------------------------------------------------------

    public static void main(String[] args) {
        // --- Get domain ID --- //
        int domainId = 0;
        if (args.length >= 1) {
            domainId = Integer.valueOf(args[0]).intValue();
        }

        // -- Get max loop count; 0 means infinite loop --- //
        int sampleCount = 0;
        if (args.length >= 2) {
            sampleCount = Integer.valueOf(args[1]).intValue();
        }

        /* Uncomment this to turn on additional logging
        Logger.get_instance().set_verbosity_by_category(
            LogCategory.NDDS_CONFIG_LOG_CATEGORY_API,
            LogVerbosity.NDDS_CONFIG_LOG_VERBOSITY_STATUS_ALL);
        */

        // --- Run --- //
        publisherMain(domainId, sampleCount);
    }

    // -----------------------------------------------------------------------
    // Private Methods
    // -----------------------------------------------------------------------

    private static ArrayList<Brightness> data;
    
    private static ArrayList<Brightness> initData() {
    	Brightness instance0 = new Brightness();
		instance0.SensorID = -1;
		instance0.Value = 0;
		
		Brightness instance1 = new Brightness();
		instance1.SensorID = -1;
		instance1.Value = 0;
		
		Brightness instance2 = new Brightness();
		instance2.SensorID = -1;
		instance2.Value = 0;
		
		Brightness instance3 = new Brightness();
		instance3.SensorID = -1;
		instance3.Value = 0;
		
		ArrayList<Brightness> list = new ArrayList<Brightness>(4);
		list.add(instance0);
		list.add(instance1);
		list.add(instance2);
		list.add(instance3);
    	
    	return list;
	}
    
    private static SolarPerformance forecast() {
    	SolarPerformance instance = null;
    	
    	if(data.get(0).SensorID != -1 && data.get(2).SensorID != -1) {
    		
    		instance = new SolarPerformance();
    		
    		if(data.get(0).Value >= 250.f && data.get(2).Value >= 250) {
    			instance.Value = "Up";
    		} else if(data.get(0).Value == 0.f && data.get(2).Value == 0) {
    	    			instance.Value = "Down";
    		} else if(data.get(0).Value > data.get(2).Value) {
    			instance.Value = "Rising";
    		} else if(data.get(0).Value < data.get(2).Value) {
    			instance.Value = "Dropping";
    		}
    		data = initData();
    		
    	}
    	
    	
    	return instance;
    }
    
    private static void printData() {
    	
    	System.out.println("-----------------------------------");
    	
		for(int i = 0; i < data.size(); i++) {
			System.out.println(data.get(i).toString());
		}
	}
    
    // --- Constructors: -----------------------------------------------------

    private SolarPerformancePublisher() {
        super();
    }

    // -----------------------------------------------------------------------

    private static void publisherMain(int domainId, int sampleCount) {

        DomainParticipant participant = null;
        Publisher publisher = null;
        Subscriber subscriber = null;
        Topic brightnessTopic = null;
        Topic solarperformanceTopic = null;
        SolarPerformanceDataWriter writer = null;
        BrightnessDataReader reader = null;
        DataReaderListener listener = null;

        data = initData();
        
        try {
            // --- Create participant --- //

            /* To customize participant QoS, use
            the configuration file
            USER_QOS_PROFILES.xml */

            participant = DomainParticipantFactory.TheParticipantFactory.
            create_participant(
                domainId, DomainParticipantFactory.PARTICIPANT_QOS_DEFAULT,
                null /* listener */, StatusKind.STATUS_MASK_NONE);
            if (participant == null) {
                System.err.println("create_participant error\n");
                return;
            }        

            // --- Create publisher --- //

            /* To customize publisher QoS, use
            the configuration file USER_QOS_PROFILES.xml */

            publisher = participant.create_publisher(
                DomainParticipant.PUBLISHER_QOS_DEFAULT, null /* listener */,
                StatusKind.STATUS_MASK_NONE);
            if (publisher == null) {
                System.err.println("create_publisher error\n");
                return;
            }                   

            // --- Create subscriber --- //
            
            subscriber = participant.create_subscriber(
            		DomainParticipant.SUBSCRIBER_QOS_DEFAULT, null,
            		StatusKind.STATUS_MASK_NONE);
            if (subscriber == null) {
            	System.err.println("create_subscriber error\n");
            	return;
            }
            
            // --- Create topic --- //

            /* Register type before creating topic */
            String typeName = SolarPerformanceTypeSupport.get_type_name();
            SolarPerformanceTypeSupport.register_type(participant, typeName);

            /* To customize topic QoS, use
            the configuration file USER_QOS_PROFILES.xml */

            solarperformanceTopic = participant.create_topic(
                "SolarPerformanceForecastTopic",
                typeName, DomainParticipant.TOPIC_QOS_DEFAULT,
                null /* listener */, StatusKind.STATUS_MASK_NONE);
            if (solarperformanceTopic == null) {
                System.err.println("create_topic error\n");
                return;
            }       
            
            typeName = BrightnessTypeSupport.get_type_name();
            BrightnessTypeSupport.register_type(participant, typeName);

            /* To customize topic QoS, use
            the configuration file USER_QOS_PROFILES.xml */

            brightnessTopic = participant.create_topic(
                "BrightnessTopic",
                typeName, DomainParticipant.TOPIC_QOS_DEFAULT,
                null /* listener */, StatusKind.STATUS_MASK_NONE);
            if (brightnessTopic == null) {
                System.err.println("create_topic error\n");
                return;
            }   

            // --- Create writer --- //

            /* To customize data writer QoS, use
            the configuration file USER_QOS_PROFILES.xml */

            writer = (SolarPerformanceDataWriter)
            publisher.create_datawriter(
                solarperformanceTopic, Publisher.DATAWRITER_QOS_DEFAULT,
                null /* listener */, StatusKind.STATUS_MASK_NONE);
            if (writer == null) {
                System.err.println("create_datawriter error\n");
                return;
            }
            
            // --- Create reader --- //
            
            listener = new BrightnessListener();
            
            reader = (BrightnessDataReader)
            subscriber.create_datareader(
            	brightnessTopic, Subscriber.DATAREADER_QOS_DEFAULT,
            	listener, StatusKind.STATUS_MASK_ALL);
            if (reader == null) {
            	System.err.println("create_datareader error\n");
            	return;
            }

            // --- Write --- //

            /* Create data sample for writing */
            SolarPerformance instance = new SolarPerformance();

            InstanceHandle_t instance_handle = InstanceHandle_t.HANDLE_NIL;
            /* For a data type that has a key, if the same instance is going to be
            written multiple times, initialize the key here
            and register the keyed instance prior to writing */
            //instance_handle = writer.register_instance(instance);

            final long sendPeriodMillis = 4 * 1000; // 4 seconds

            for (int count = 0;
            (sampleCount == 0) || (count < sampleCount);
            ++count) {
                //printData();

                /* Modify the instance to be written here */
                SolarPerformance spf = forecast();
                
                if(spf != null) {
                	System.out.println("Solar Performance Forecast" + spf.toString());
                	writer.write(spf, instance_handle);
                }
                
                try {
                    Thread.sleep(sendPeriodMillis);
                } catch (InterruptedException ix) {
                    System.err.println("INTERRUPTED");
                    break;
                }
            }

            //writer.unregister_instance(instance, instance_handle);

        } finally {

            // --- Shutdown --- //

            if(participant != null) {
                participant.delete_contained_entities();

                DomainParticipantFactory.TheParticipantFactory.
                delete_participant(participant);
            }
            /* RTI Data Distribution Service provides finalize_instance()
            method for people who want to release memory used by the
            participant factory singleton. Uncomment the following block of
            code for clean destruction of the participant factory
            singleton. */
            //DomainParticipantFactory.finalize_instance();
        }
    }
    
    private static class BrightnessListener extends DataReaderAdapter {

        BrightnessSeq _dataSeq = new BrightnessSeq();
        SampleInfoSeq _infoSeq = new SampleInfoSeq();

        public void on_data_available(DataReader reader) {
            BrightnessDataReader BrightnessReader =
            (BrightnessDataReader)reader;

            try {
                BrightnessReader.take(
                    _dataSeq, _infoSeq,
                    ResourceLimitsQosPolicy.LENGTH_UNLIMITED,
                    SampleStateKind.ANY_SAMPLE_STATE,
                    ViewStateKind.ANY_VIEW_STATE,
                    InstanceStateKind.ANY_INSTANCE_STATE);

                for(int i = 0; i < _dataSeq.size(); ++i) {
                    SampleInfo info = (SampleInfo)_infoSeq.get(i);

                    if (info.valid_data) {
                        System.out.println(
                            ((Brightness)_dataSeq.get(i)).toString("Received",0));
                        
                        Brightness instance = new Brightness(_dataSeq.get(i));
                        data.set(instance.SensorID, instance);
                    }
                }
            } catch (RETCODE_NO_DATA noData) {
                // No data to process
            } finally {
                BrightnessReader.return_loan(_dataSeq, _infoSeq);
            }
        }
    }
}

